/******************************************************************************
*                                                                             *
*                           FWKatanaPACK.rexx V1.0                            *
*                                                                             *
*           ARexx Interface Script for Final Writer, using XPKatana           *
*                                                                             *
*          This script compress and save files made by Final Writer.          *
*            XPKatana's "Pack ?" is used to bring up a requester.             *
*                                                                             *
*                   Uses ARexx Ports "KATANA" and "FINALW.1"                  *
*                                                                             *
*        Written by Rmi Ltourneau & Eric Sauvageau, December 20th 1995      *
*                                                                             *
******************************************************************************/

  OPTIONS RESULTS
  SIGNAL ON ERROR

/* Change this as needed */
PACKER = "NUKE"    /* Packer to use */

XPKATANA_PATH = "SYS:Utilities/XPKatana"


/* FIRST, we have TO actually Verify is XPKatana is running.           */
  If ~SHOW('p',"KATANA") Then Do

/* IF XPKatana is not already running, start it in iconified state. */
        start = 1
        ADDRESS COMMAND "run <>NIL: "||XPKATANA_PATH||" ICONIFY"
        ADDRESS COMMAND "WaitForPort KATANA"
  END


/* Speak to the Final Writer Port that started this script and save    */
/* the file with the filename that we got from XPKatana's Requester    */
  ADDRESS "FINALW.1"
  SAVE "T:FWXPK_TMP"


/* Go back to XPKatana */
  ADDRESS 'KATANA'

/* Get the source file */
  SETSOURCE "T:FWXPK_TMP"

/* Set the packer */
  SETPACKER PACKER 100

/* Set XPKatana to "No progress window", "Handle Suffix" and 
   "Delete source." */
  SETFLAGS NOPROGRESS 1 SUFFIX 1 DELSOURCE 1

/* Pack the file, asking for the destination filename   */

  PACK "?"

  /* error = result
  If error = "ABORT" Then Do
     Say "Packing aborted or failed!"
  End
  Else Do
    Say "Packed."
  End
  */

/* Quit XPKatana */
  If start = 1 Then  Quit
